Bug 2267261 - Review Request: fbgemm - Facebook General Matrix-Matrix Multiplication library
Summary: Review Request: fbgemm - Facebook General Matrix-Matrix Multiplication library
Keywords:
Status: CLOSED RAWHIDE
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: Unspecified
OS: Linux
unspecified
medium
Target Milestone: ---
Assignee: Jeremy Cline
QA Contact: Fedora Extras Quality Assurance
URL: https://github.com/pytorch/%{name}
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2024-03-01 14:13 UTC by Ali Erdinc Koroglu
Modified: 2024-07-08 17:44 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2024-07-08 17:44:35 UTC
Type: ---
Embargoed:
jeremy: fedora-review+


Attachments (Terms of Use)
The .spec file difference from Copr build 7095171 to 7427021 (1.87 KB, patch)
2024-05-08 16:42 UTC, Fedora Review Service
no flags Details | Diff

Description Ali Erdinc Koroglu 2024-03-01 14:13:53 UTC
SPEC Url: https://download.copr.fedorainfracloud.org/results/aekoroglu/fedora/fedora-rawhide-x86_64/07095100-fbgemm/fbgemm.spec
SRPM Url: https://download.copr.fedorainfracloud.org/results/aekoroglu/fedora/fedora-rawhide-x86_64/07095100-fbgemm/fbgemm-0.6.0-1.fc41.src.rpm

Description:
FBGEMM (Facebook GEneral Matrix Multiplication) is a low-precision, high
performance matrix-matrix multiplications and convolution library for
server-side inference.

The library provides efficient low-precision general matrix multiplication for
small batch sizes and support for accuracy-loss minimizing techniques such as
row-wise quantization and outlier-aware quantization. FBGEMM also exploits
fusion opportunities in order to overcome the unique challenges of matrix
multiplication at lower precision with bandwidth-bound operations.

FBGEMM is used as a backend of Caffe2 and PyTorch quantized operators for x86 machines.

Reproducible: Always

Comment 1 Fedora Review Service 2024-03-01 14:25:48 UTC
Copr build:
https://copr.fedorainfracloud.org/coprs/build/7095171
(succeeded)

Review template:
https://download.copr.fedorainfracloud.org/results/@fedora-review/fedora-review-2267261-fbgemm/fedora-rawhide-x86_64/07095171-fbgemm/fedora-review/review.txt

Please take a look if any issues were found.


---
This comment was created by the fedora-review-service
https://github.com/FrostyX/fedora-review-service

If you want to trigger a new Copr build, add a comment containing new
Spec and SRPM URLs or [fedora-review-service-build] string.

Comment 2 Jeremy Cline 2024-03-07 15:30:25 UTC
Hi,

This looks very nearly there, there's just one small issue with the description on fbgemm-devel. If you want to share the description between fbgemm and fbgemm-devel you need to define it. I think you need to do something like:

%global _description %{expand:
	
Write your description here.

You can then use _description to reference it later.
}

%description %{_description}

Comment 3 Ali Erdinc Koroglu 2024-05-08 16:15:05 UTC
Hello again, sorry for late response

SPEC Url: https://download.copr.fedorainfracloud.org/results/aekoroglu/fedora/fedora-rawhide-x86_64/07426964-fbgemm/fbgemm.spec
SRPM Url: https://download.copr.fedorainfracloud.org/results/aekoroglu/fedora/fedora-rawhide-x86_64/07426964-fbgemm/fbgemm-0.6.0-1.fc41.src.rpm

PS: I'm aware that fbgemm has a new version (0.7.0) but I found interesting cpu instruction issue on testing.

Comment 4 Fedora Review Service 2024-05-08 16:42:38 UTC
Created attachment 2032208 [details]
The .spec file difference from Copr build 7095171 to 7427021

Comment 5 Fedora Review Service 2024-05-08 16:42:40 UTC
Copr build:
https://copr.fedorainfracloud.org/coprs/build/7427021
(succeeded)

Review template:
https://download.copr.fedorainfracloud.org/results/@fedora-review/fedora-review-2267261-fbgemm/fedora-rawhide-x86_64/07427021-fbgemm/fedora-review/review.txt

Please take a look if any issues were found.


---
This comment was created by the fedora-review-service
https://github.com/FrostyX/fedora-review-service

If you want to trigger a new Copr build, add a comment containing new
Spec and SRPM URLs or [fedora-review-service-build] string.

Comment 6 Jeremy Cline 2024-06-21 16:23:11 UTC
Ah, thanks for the ping.

- The latest version isn't packaged, but as you indicated you're aware of it and there's a problem, I think that's okay.
- The patch is fairly self-explanatory, but it would be nice to add a little comment above it in the specfile explaining what it's there for.

Approved!


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: If your application is a C or C++ application you must list a
     BuildRequires against gcc, gcc-c++ or clang.
[x]: Header files in -devel subpackage, if present.
[x]: ldconfig not called in %post and %postun for Fedora 28 and later.
[x]: Package does not contain any libtool archives (.la)
[x]: Package contains no static executables.
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "BSD 3-Clause License". 497 files have
     unknown license. Detailed output of licensecheck in
     /home/jcline/reviews/2267261-fbgemm/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: The License field must be a valid SPDX expression.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 6072 bytes in 1 files.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[!]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: fbgemm-0.6.0-1.fc41.x86_64.rpm
          fbgemm-devel-0.6.0-1.fc41.x86_64.rpm
          fbgemm-debuginfo-0.6.0-1.fc41.x86_64.rpm
          fbgemm-debugsource-0.6.0-1.fc41.x86_64.rpm
          fbgemm-0.6.0-1.fc41.src.rpm
================================================================================================================================ rpmlint session starts ================================================================================================================================
rpmlint: 2.5.0
configuration:
    /usr/lib/python3.12/site-packages/rpmlint/configdefaults.toml
    /etc/xdg/rpmlint/fedora-legacy-licenses.toml
    /etc/xdg/rpmlint/fedora-spdx-licenses.toml
    /etc/xdg/rpmlint/fedora.toml
    /etc/xdg/rpmlint/scoring.toml
    /etc/xdg/rpmlint/users-groups.toml
    /etc/xdg/rpmlint/warn-on-functions.toml
rpmlintrc: [PosixPath('/tmp/tmpmqr6whra')]
checks: 32, packages: 5

fbgemm-devel.x86_64: W: no-documentation
========================================================================================== 5 packages and 0 specfiles checked; 0 errors, 1 warnings, 30 filtered, 0 badness; has taken 1.3 s ===========================================================================================




Rpmlint (debuginfo)
-------------------
Checking: fbgemm-debuginfo-0.6.0-1.fc41.x86_64.rpm
================================================================================================================================ rpmlint session starts ================================================================================================================================
rpmlint: 2.5.0
configuration:
    /usr/lib/python3.12/site-packages/rpmlint/configdefaults.toml
    /etc/xdg/rpmlint/fedora-legacy-licenses.toml
    /etc/xdg/rpmlint/fedora-spdx-licenses.toml
    /etc/xdg/rpmlint/fedora.toml
    /etc/xdg/rpmlint/scoring.toml
    /etc/xdg/rpmlint/users-groups.toml
    /etc/xdg/rpmlint/warn-on-functions.toml
rpmlintrc: [PosixPath('/tmp/tmpl5mxhhr6')]
checks: 32, packages: 1

=========================================================================================== 1 packages and 0 specfiles checked; 0 errors, 0 warnings, 5 filtered, 0 badness; has taken 0.6 s ===========================================================================================





Rpmlint (installed packages)
----------------------------
============================ rpmlint session starts ============================
rpmlint: 2.5.0
configuration:
    /usr/lib/python3.13/site-packages/rpmlint/configdefaults.toml
    /etc/xdg/rpmlint/fedora-legacy-licenses.toml
    /etc/xdg/rpmlint/fedora-spdx-licenses.toml
    /etc/xdg/rpmlint/fedora.toml
    /etc/xdg/rpmlint/scoring.toml
    /etc/xdg/rpmlint/users-groups.toml
    /etc/xdg/rpmlint/warn-on-functions.toml
checks: 32, packages: 4

fbgemm-devel.x86_64: W: no-documentation
 4 packages and 0 specfiles checked; 0 errors, 1 warnings, 26 filtered, 0 badness; has taken 0.7 s 



Source checksums
----------------
https://github.com/pytorch/fbgemm/archive/v0.6.0/fbgemm-0.6.0.tar.gz :
  CHECKSUM(SHA256) this package     : e9231d40a32095b9979205f986a4dae88ac9e648984361c2515538c4f009b0e8
  CHECKSUM(SHA256) upstream package : e9231d40a32095b9979205f986a4dae88ac9e648984361c2515538c4f009b0e8


Requires
--------
fbgemm (rpmlib, GLIBC filtered):
    libasmjit.so.0.0.20231007()(64bit)
    libc.so.6()(64bit)
    libcpuinfo.so.23.11.04()(64bit)
    libgcc_s.so.1()(64bit)
    libgcc_s.so.1(GCC_3.0)(64bit)
    libgomp.so.1()(64bit)
    libgomp.so.1(GOMP_1.0)(64bit)
    libgomp.so.1(GOMP_4.0)(64bit)
    libgomp.so.1(OMP_1.0)(64bit)
    libm.so.6()(64bit)
    libstdc++.so.6()(64bit)
    libstdc++.so.6(CXXABI_1.3)(64bit)
    libstdc++.so.6(CXXABI_1.3.11)(64bit)
    libstdc++.so.6(CXXABI_1.3.13)(64bit)
    libstdc++.so.6(CXXABI_1.3.15)(64bit)
    libstdc++.so.6(CXXABI_1.3.3)(64bit)
    libstdc++.so.6(CXXABI_1.3.5)(64bit)
    libstdc++.so.6(CXXABI_1.3.7)(64bit)
    libstdc++.so.6(CXXABI_1.3.9)(64bit)
    rtld(GNU_HASH)

fbgemm-devel (rpmlib, GLIBC filtered):
    cmake-filesystem(x86-64)
    fbgemm(x86-64)
    libfbgemm.so.1()(64bit)

fbgemm-debuginfo (rpmlib, GLIBC filtered):

fbgemm-debugsource (rpmlib, GLIBC filtered):



Provides
--------
fbgemm:
    fbgemm
    fbgemm(x86-64)
    libfbgemm.so.1()(64bit)

fbgemm-devel:
    cmake(fbgemmLibrary)
    cmake(fbgemmlibrary)
    fbgemm-devel
    fbgemm-devel(x86-64)

fbgemm-debuginfo:
    debuginfo(build-id)
    fbgemm-debuginfo
    fbgemm-debuginfo(x86-64)
    libfbgemm.so.0.1-0.6.0-1.fc41.x86_64.debug()(64bit)

fbgemm-debugsource:
    fbgemm-debugsource
    fbgemm-debugsource(x86-64)



Generated by fedora-review 0.10.0 (e79b66b) last change: 2023-07-24
Command line :/usr/bin/fedora-review -b 2267261
Buildroot used: fedora-rawhide-x86_64
Active plugins: C/C++, Generic, Shell-api
Disabled plugins: Java, SugarActivity, Haskell, Perl, Python, PHP, fonts, R, Ocaml
Disabled flags: EXARCH, EPEL6, EPEL7, DISTTAG, BATCH

Comment 7 Fedora Admin user for bugzilla script actions 2024-06-25 13:20:12 UTC
The Pagure repository was created at https://src.fedoraproject.org/rpms/fbgemm


Note You need to log in before you can comment on or make changes to this bug.